;**********************************************************************
table_type_32
;**********************************************************************
;
;  25 bytes
;  24 bytes - LED bits
;   1 byte  - controll
;
;    var fcount1 ;, b2l_out_hi
    var p2count

    movlw        LOW in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H

    movlw        0x19
    movwf        fcount1

t32_loop
    call         get_next_pattern_entry
    movwi        INDF0++

    decfsz       fcount1,f
    goto         t32_loop

    movfw        in18
    movwf        p2count
    lslf         p2count,f

    btfsc        in18,7
    call         display_1bit

t32_fader_loop
;
;   We assume all the LED memory locations are sequental
;
    movlw        LOW Led_000R        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH Led_000R
    movwf        FSR0H

    movfw        in0
    movwf        tempr
    movfw        in1
    movwf        tempg
    movfw        in2
    movwf        tempb
    call         d2b_24bits_fader

    movfw        in3
    movwf        tempr
    movfw        in4
    movwf        tempg
    movfw        in5
    movwf        tempb
    call         d2b_24bits_fader

    movfw        in6
    movwf        tempr
    movfw        in7
    movwf        tempg
    movfw        in8
    movwf        tempb
    call         d2b_24bits_fader

    movfw        in9
    movwf        tempr
    movfw        ina
    movwf        tempg
    movfw        inb
    movwf        tempb
    call         d2b_24bits_fader

    movfw        inc
    movwf        tempr
    movfw        ind
    movwf        tempg
    movfw        ine
    movwf        tempb
    call         d2b_24bits_fader

    movfw        inf
    movwf        tempr
    movfw        in10
    movwf        tempg
    movfw        in11
    movwf        tempb
    call         d2b_24bits_fader

    movfw        in12
    movwf        tempr
    movfw        in13
    movwf        tempg
    movfw        in14
    movwf        tempb
    call         d2b_24bits_fader

    movfw        in15
    movwf        tempr
    movfw        in16
    movwf        tempg
    movfw        in17
    movwf        tempb
    call         d2b_24bits_fader

;    movfw        pspeed
    movlw        0x01           ; if this where the slowdown bug is?
    call         strobe_delay

 ;   btfsc        button,0    ; if putton pressed show pattern id
 ;   goto         t20_exit

    btfsc        IR_in_good,0
    goto         t20_exit

    decfsz       p2count,f
    goto         t32_fader_loop

t20_exit
    return

;**********************************************************************
d2b_24bits_fader
;**********************************************************************

    btfsc        tempr,7
    call         p18_led_up
    btfss        tempr,7
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempg,7
    call         p18_led_up
    btfss        tempg,7
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempb,7
    call         p18_led_up
    btfss        tempb,7
    call         p18_led_down

    moviw        INDF0++
;--
    btfsc        tempr,6
    call         p18_led_up
    btfss        tempr,6
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempg,6
    call         p18_led_up
    btfss        tempg,6
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempb,6
    call         p18_led_up
    btfss        tempb,6
    call         p18_led_down

    moviw        INDF0++
;--
    btfsc        tempr,5
    call         p18_led_up
    btfss        tempr,5
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempg,5
    call         p18_led_up
    btfss        tempg,5
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempb,5
    call         p18_led_up
    btfss        tempb,5
    call         p18_led_down

    moviw        INDF0++
;--
    btfsc        tempr,4
    call         p18_led_up
    btfss        tempr,4
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempg,4
    call         p18_led_up
    btfss        tempg,4
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempb,4
    call         p18_led_up
    btfss        tempb,4
    call         p18_led_down

    moviw        INDF0++
;--
    btfsc        tempr,3
    call         p18_led_up
    btfss        tempr,3
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempg,3
    call         p18_led_up
    btfss        tempg,3
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempb,3
    call         p18_led_up
    btfss        tempb,3
    call         p18_led_down

    moviw        INDF0++
;--
    btfsc        tempr,2
    call         p18_led_up
    btfss        tempr,2
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempg,2
    call         p18_led_up
    btfss        tempg,2
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempb,2
    call         p18_led_up
    btfss        tempb,2
    call         p18_led_down

    moviw        INDF0++
;--
    btfsc        tempr,1
    call         p18_led_up
    btfss        tempr,1
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempg,1
    call         p18_led_up
    btfss        tempg,1
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempb,1
    call         p18_led_up
    btfss        tempb,1
    call         p18_led_down

    moviw        INDF0++
;--
    btfsc        tempr,0
    call         p18_led_up
    btfss        tempr,0
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempg,0
    call         p18_led_up
    btfss        tempg,0
    call         p18_led_down

    moviw        INDF0++

    btfsc        tempb,0
    call         p18_led_up
    btfss        tempb,0
    call         p18_led_down

    moviw        INDF0++
;--
    return

;**********************************************************************
p18_led_up
;**********************************************************************

    incf        INDF0,f
    btfsc       STATUS,Z
    comf        INDF0,f
    return

;**********************************************************************
p18_led_down
;**********************************************************************

    movf        INDF0,f
    btfss       STATUS,Z
    decf        INDF0,f
    return
