    var tempa

;-------------------------------------------------------------------------------
display_cycle0
;-------------------------------------------------------------------------------

    movlw   b'00000100'
    MOVWF tempa

display_cycle0l

    movlw  LOW Led_000R
    movwf  FSR0L
    movlw  HIGH Led_000R
    movwf  FSR0H

    call   common_strobe
 

    call   write_RGB


    decfsz  fcount,f
    goto    display_cycle0l

    goto return_display_cycle


;-------------------------------------------------------------------------------
display_cycle1
;-------------------------------------------------------------------------------

    MOVLW b'00000001'
    MOVWF tempa  

display_cycle1l
    
    movlw  LOW Led_020R
    movwf  FSR0L
    movlw  HIGH Led_020R
    movwf  FSR0H

    call   common_strobe


    call   write_RGB

    decfsz  fcount,f
    goto    display_cycle1l

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle2
;-------------------------------------------------------------------------------


    MOVLW b'00000010'
    MOVWF tempa 

display_cycle2l

    movlw  LOW Led_100R
    movwf  FSR0L
    movlw  HIGH Led_100R
    movwf  FSR0H

    call   common_strobe
    call   write_RGB

    decfsz  fcount,f
    goto    display_cycle2l

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle3
;-------------------------------------------------------------------------------


    MOVLW b'00001000'
    MOVWF tempa  

display_cycle3l

    movlw  LOW Led_120R
    movwf  FSR0L
    movlw  HIGH Led_120R
    movwf  FSR0H

    call   common_strobe
    call   write_RGB

    decfsz  fcount,f
    goto    display_cycle3l

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle4
;------------------------------------------------------------------------------


    MOVLW b'01000000'
    MOVWF tempa
  
display_cycle4l

    movlw  LOW Led_200R
    movwf  FSR0L
    movlw  HIGH Led_200R
    movwf  FSR0H

    call   common_strobe
    call   write_RGB

    decfsz  fcount,f
    goto    display_cycle4l

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle5
;-------------------------------------------------------------------------------


    MOVLW b'00010000'
    MOVWF tempa  

display_cycle5l

    movlw  LOW Led_220R
    movwf  FSR0L
    movlw  HIGH Led_220R
    movwf  FSR0H

    call   common_strobe
    call   write_RGB

    decfsz  fcount,f
    goto    display_cycle5l

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle6
;-------------------------------------------------------------------------------


    MOVLW b'10000000'
    MOVWF tempa  

display_cycle6l

    movlw  LOW Led_300R
    movwf  FSR0L
    movlw  HIGH Led_300R
    movwf  FSR0H

    call   common_strobe
    call   write_RGB

    decfsz  fcount,f
    goto    display_cycle6l

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle7
;-------------------------------------------------------------------------------


    MOVLW b'00100000'
    MOVWF tempa  

display_cycle7l

    movlw  LOW Led_320R
    movwf  FSR0L
    movlw  HIGH Led_320R
    movwf  FSR0H

    call   common_strobe
    call   write_RGB

    decfsz  fcount,f
    goto    display_cycle7l

    goto return_display_cycle

;-------------------------------------------------------------------------------
common_strobe
;-------------------------------------------------------------------------------

    clrf    out_red
    clrf    out_green
    clrf    out_blue

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_red,   0

    MOVIW INDF0++    

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_green,   0

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_blue,   0

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_red,   1

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_green,   1

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_blue,   1

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_red,   2

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_green,   2

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_blue,   2

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_red,   3

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_green,   3

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_blue,   3

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_red,   4

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_green,   4

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_blue,   4

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_red,   5

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_green,   5

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_blue,   5

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_red,   6

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_green,   6

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_blue,   6

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_red,   7

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_green,   7

    MOVIW INDF0++

    movfw   TMR0
    subwf   INDF0,w
    btfsc   STATUS,C
    bsf     out_blue,   7

    return


;**********************************************************************
write_RGB
;**********************************************************************
    var out_red
    var out_green
    var out_blue

;   write SSPBUF
    BANKSEL out_green 
    movfw out_green
    BANKSEL SSPBUF
    movwf SSPBUF
;   wait for BF to go 1
    BANKSEL SSPSTAT
loop_wait_green
#ifndef SIM_DEBUG
    btfss   SSPSTAT,BF
    goto loop_wait_green
#endif
;   dumby read of SSPBUF
    BANKSEL SSPBUF
    movfw SSPBUF
;   write SSPBUF
    BANKSEL out_red 
    movfw out_red
    BANKSEL SSPBUF
    movwf SSPBUF
;   wait for BF to go 1
loop_wait_red
#ifndef SIM_DEBUG
    btfss   SSPSTAT,BF
    goto loop_wait_red
#endif
;   dumby read of SSPBUF
    BANKSEL SSPBUF
    movfw SSPBUF
;   write SSPBUF
    BANKSEL out_blue 
    movfw out_blue
    BANKSEL SSPBUF
    movwf SSPBUF
;   wait for BF to go 1
loop_wait_blue
#ifndef SIM_DEBUG
    btfss   SSPSTAT,BF
    goto loop_wait_blue
#endif
;   dumby read of SSPBUF
    BANKSEL SSPBUF
    movfw SSPBUF

    BANKSEL PORTA
    clrf   PORTA

    BANKSEL PORTC
    bsf    PORTC,2         ; Strobe Data latch hi
    nop
    nop
    nop
    bcf    PORTC,2         ; Strobe Data latch low

    BANKSEL tempa
    movfw  tempa
    movwf  PORTA

    return

